library completable;

import 'package:flutter/material.dart';

class Completable extends StatelessWidget {
  final Key key;
  final Function confirmDismiss;
  final Function onCompleted;
  final Function onPressed;
  final Color color;
  final Color colorBorder;
  final Widget backgroundDismiss;
  final Widget backgroundComplete;
  final Widget child;
  final Widget childComplete;
  final bool completed;

  Completable({
    this.key,
    this.confirmDismiss,
    this.onCompleted,
    this.onPressed,
    this.color,
    this.colorBorder,
    this.backgroundDismiss,
    this.backgroundComplete,
    this.child,
    this.childComplete,
    this.completed,
  });

  @override
  Widget build(BuildContext context) {
    return Dismissible(
      key: key,
      confirmDismiss: (direction) {
        if (direction == DismissDirection.startToEnd) {
          onCompleted();
          return Future.value(false);
        }

        return confirmDismiss();
      },
      background: backgroundComplete,
      secondaryBackground: backgroundDismiss,
      child: FlatButton(
        padding: const EdgeInsets.all(0.0),
        color: color,
        onPressed: onPressed,
        child: Container(
          decoration: BoxDecoration(
            border: Border(
              bottom: BorderSide(
                width: 1.0,
                color: colorBorder,
              ),
            ),
          ),
          child: Row(
            children: <Widget>[
              completed
                ? childComplete
                : Container(),
              Flexible(
                child: child,
              ),
            ],
          ),
        ),
      )
    );
  }
}